# $Id: config_ctrl.rb,v 1.2 2004/12/25 01:59:34 toki Exp $

require 'wpm'
require 'wpm/rucydriver'
require 'wpm/rexml'
require 'yaml/store'
require 'rucy/jconv'
require 'rucy/properties'
require 'rucy/params'
require 'rucy/control'

module Rucy
  module Config
    def config_ctrl(rep)
      # for wpm
      rep.set_block(:WebPageMakerDocument) { WebPageMakerDocument.new(WPM::XMLAssistByREXML) }

      # for rucy/jconv
      rep.set_block(:Jconv) { Jconv.new(rep) }

      # for rucy/properties
      rep.set_class(:Store, YAML::Store)
      rep.set_block(:Properties) {|path| Properties.new(path, rep) }

      # for rucy/params
      rep.set_block(:AdminParams) { AdminParams.new(rep) }
      rep.set_value(:AdminParamsClass, AdminParams)
      rep.set_block(:ServerParams) { ServerParams.new(rep) }
      rep.set_value(:ServerParamsClass, ServerParams)
      rep.set_block(:LoggingParams) { LoggingParams.new(rep) }
      rep.set_value(:LoggingParamsClass, LoggingParams)
      rep.set_block(:AccessLogParams) { AccessLogParams.new(rep) }
      rep.set_value(:AccessLogParamsClass, AccessLogParams)
      rep.set_block(:AliasList) { AliasList.new(rep) }
      rep.set_value(:AliasListClass, AliasList)
      rep.set_block(:DocumentList) {|factory| DocumentList.new(factory, rep) }
      rep.set_value(:DocumentListClass, DocumentList)
      rep.set_block(:FilterList) {|factory| FilterList.new(factory, rep) }
      rep.set_value(:FilterListClass, FilterList)

      # for rucy/control
      rep.set_block(:Control) { Control.new(rep) }

      rep
    end
    module_function :config_ctrl
  end
end
